utility getawayImport "The Getaway ps2 import" 
(
	--vars
	local currentPath=""
	local fileSize
	
	--user interface
	group "About"
	(
		label lab1 "Getaway import ver 0"
	)
		
	group "Import"
	(
		button importButton "Import..."
	)
	
	on importButton pressed do
	(
		-- Open up a dialog box
		objFileName = getOpenFileName caption:"Import OBJ" \
					types:"Wavefront OBJ (All Files (*.*)"
					
		-- If user made a selection, begin importing
		if objFileName != undefined then
		(
			currentPath = getFilenamePath objFileName
			
			-- Open up the file
			f = fopen objFileName "rb"
			
			--find end of file
			fseek f 0 #seek_end
			local fileSize = ftell f
			fseek f 0 #seek_set
			print ("fileSize = " + fileSize as string)		
			
			local meshOffset = 0
			local temp = 0
				
			try
			(
				local meshCount = 0
				
				--find 'model' header
				while ftell f < fileSize do
				(
					--check if 16 bytes line begins with "m"
					temp = ReadByte f #unsigned
					if temp!=109 then
					(
						fseek f 15 #seek_cur
					)

					
					else
					(
						meshOffset = (ftell f)-1
					
						--check if next char is "o"
						temp = ReadByte f #unsigned
						
						if temp==111 then
						
						--check if next char is "d"
						temp = ReadByte f #unsigned
					
						if temp==100 then
						(
							print "model found"
							meshCount += 1
							local meshName = meshCount
								
							--hop to mesh data size value
							fseek f 5 #seek_cur
							local meshDataSize = ReadLong f #unsigned
							print ("meshDataSize = " + meshDataSize as string)
								
							--read mesh position (unconfirmed)
							local meshPos = #(0,0,0)
							meshPos [1] = ReadByte f #signed
							meshPos [2] = ReadByte f #signed
							meshPos [3] = ReadByte f #signed
							print "meshPos (probably):"
							print meshPos
							
							--move to final VIF tag (separated to allow vertCount seek to deal with submeshes)
							fseek f 33 #seek_cur
							
							
							local verts = #()
							local norms = #()
							local uvs = #()
							local linearBuffer = #(1,2,3)
							local faces = #()
							while (ftell f < (meshOffset + 16 + meshDataSize)) do
							(	
								--check for VIF tag which precedes submesh (to skip 'leftover' data)
								temp = ReadLong f #unsigned
								if (temp != 1761771520) then exit
								
								--move to and read vertex count 
								fseek f 14 #seek_cur
								local vertCount = ReadByte f #unsigned
								print ("vertCount = " + vertCount as string)
							
								--move to start of vertices and construct array
								fseek f 1 #seek_cur
								local vertIndex = 1
								while vertIndex <= vertCount do
								(
									temp = [0,0,0]
									temp [1] = ReadShort f #signed
									temp [2] = ReadShort f #signed
									temp [3] = ReadShort f #signed
									append verts temp
									vertIndex += 1
								)
								print "verts"
								print verts
							
							
								--move to start of normals and read (need to check format, need -1 to 1?)
								temp = ftell f					--16 byte align
								temp = mod temp 16
								temp = 16 - temp
								fseek f temp #seek_cur
								fseek f 4 #seek_cur				--skip 4 byte tag/VIF code
								local normIndex = 1
								while normIndex <= vertCount do
								(
									temp = [0,0,0]
									temp [1] = ReadByte f #signed
									temp [2] = ReadByte f #signed
									temp [3] = ReadByte f #signed
									append norms temp
									normIndex += 1
								)
								print "norms"
								--print norms

							
								--move to start of UVs and read
								temp = ftell f					--16 byte align
								temp = mod temp 16 
								temp = 16 - temp
								fseek f temp #seek_cur
								fseek f 4 #seek_cur				--skip 4 byte tag/VIF code
								local uvIndex = 1
								while uvIndex <= vertCount do
								(
									temp = [0,0,0]
									temp [1] = ReadShort f #unsigned
									temp [2] = ReadShort f #unsigned
									temp [3] = 0
									append uvs temp
									uvIndex += 1
								)
								print "uvs"
								--print uvs
							
							
								--construct face list (using basic tri-strip for now)
								
								local faceIndex = 1
								while faceIndex < (vertCount-1) do
								(
									temp = [0,0,0]
							
									if (mod faceIndex 2)!=0 then
									(
										temp [1] =  linearBuffer [1]
										temp [2] =  linearBuffer [2]
										temp [3] =  linearBuffer [3]
									) 
								
									else
									(
										temp [1] =  linearBuffer [3]
										temp [2] =  linearBuffer [2]
										temp [3] =  linearBuffer [1]
									)
									
									append faces temp
								
									--increment buffer for next face (standard tri-strip)
									append linearBuffer (linearBuffer[3] + 1)
									deleteItem linearBuffer 1
								
									faceIndex += 1
								)
								--restart tri-strip ready for next submesh (if present)
								linearBuffer [1] += 2
								linearBuffer [2] += 2
								linearBuffer [3] += 2
								print "faces"
								print faces
								
								--realign to 00 column to continue 'model' search (or read next submesh vertCount)
								temp = ftell f					--16 byte align
								temp = mod temp 16 
								if temp>0 then
								(
									temp = 16 - temp
								)
								fseek f temp #seek_cur
								print ("next submesh" + ftell f as string)
							)
							
							--create mesh in 3ds max scene
							temp = mesh vertices:verts faces:faces tverts:uvs
							--fix to apply tverts to faces
							buildTVFaces temp.mesh
							for i = 1 to temp.mesh.numfaces do
							(
								setTVFace temp.mesh i (getFace temp.mesh i)
								
								--set face normals to match vertex normals
								setFaceNormal temp.mesh i (norms [(getFace temp.mesh i)[1]] + norms [(getFace temp.mesh i)[2]] + norms [(getFace temp.mesh i)[3]]) /3
							)
							
							--END OF MODEL
							print "------------------------------------------"
							
							
							temp = undefined
						)
					)
				)
				temp = meshCount as string
				print ("Mesh Count = " + temp)
				
			)
			
			catch
			(
				messageBox "No mesh detected"
				throw
			)
		)
	)
)